# Was heute gemacht wird

Heute richten wir uns die Arbeitsumgebung ein. Dazu gehört die Anbindung an *Gitea*. Das ist ein Service ähnlich wie *Github*, auf welchem man seinen Code hochladen kann. Im Hintergrund läuft die Versionierungssoftware `git`, mit Hilfe man seine Fortschritte überwachen und ggf. auch wieder seinen Code auf einen früheren Zustand zurücksetzen kann.
Ziel dieser Stunde ist es nun, ein Repository (einen Ordner) in *Gitea* anzulegen und diesen dann mit eurer lokalen Instanz zu verknüpfen.

## Repository auf gitea.mdg-hamburg.de anlegen
1. Gehe auf [gitea.mdg-hamburg.de](https://gitea.mdg-hamburg.de) und melde dich mit deinen iServ-Zugangsdaten an.
2. Klicke oben rechts auf das "+"-Symbol und wähle "Neues Repository".
3. Gib deinem Repository einen Namen. 
4. Wähle *VisualStudioCode* beim Feld ".gitignore"
5. Wähle eine Lizenz aus. Ich empfehle die *CC-BY-NC-SA-4.0*. Diese Lizenz stellt sicher, dass dein Code von anderen für nicht kommerzielle Zwecke weiterverwendet werden darf. Allerdings muss die Herkunft des Codes gekennzeichnet werden und sie müssen den Code unter der selben Lizenz veröffentlichen. Weitere Informationen findest du hier: [Creative Commons Lizenzen](https://creativecommons.org/licenses/?lang=de).
6. Auf "Repository erstellen" klicken.

## SSH-Key erstellen
Dein Repository ist privat, d.h. ohne Anmeldedaten ist es nicht einfach abrufbar. Damit du nicht immer deine Zugangsdaten angeben musst, wird ein SSH-Key erstellt, welcher als Zugangsschlüssel fungieren wird. Diese Anleitung ist für ein Linux-System geschrieben. 
1. Öffne das **Terminal** auf dem Schullaptop indem du gleichzeitig die Tasten "Strg", "Alt" und "T" drückst.
2. Gib die folgenden Befehle in das Terminal ein und drücke jeweils Enter: 
- ```mkdir -p .ssh```
- ```cd .ssh```
- `ssh-keygen`. Als "Enter file in which to save the key" gibst du *gitea-mdg* an. Alles andere ohne Eingabe nur mit Enter bestätigen.
- `gedit config`. Kopiere folgenden Text und füge ihn in das Dokument ein. Klicke danach auf Speichern und schließe dann den Texteditor:
```
    Host gitea.mdg-hamburg.de
        HostName gitea.mdg-hamburg.de
        IdentityFile ~/.ssh/gitea-mdg
        User git
        Port 2022
```
- `cat gitea-mdg.pub`. Markiere die Ausgabe und kopiere sie. 
3. Gehe wieder auf [gitea.mdg-hamburg.de](https://gitea.mdg-hamburg.de) und klicke auf das lilane Symbol oben rechts in der Ecke und wähle "Einstellungen" aus.
4. Wähle in der horizontalen Menüleiste oben "SSH- / GPG-Schlüssel" aus.
5. Wähle "SSH-Schlüssel hinzufügen" und füge den zuvor kopierten Schlüssel in das Feld "Inhalt" ein. Danach auf das grüne Feld "Schlüssel hinzufügen" klicken. 

## Repository per VisualStudio Code abrufen und bearbeiten
1. Gehe wieder auf gitea und kopiere den https Link für dein Repository:
![Gitea](https://gitea.mdg-hamburg.de/Informatikkurs-10-23_24/Erste-Stunde/src/branch/master/gitea1.png "Gitea")
1. Öffne **VisualStudio Code** indem du die Windows-Taste einmal drückst und dann "Code" tippst. Bestätige mit Enter.
2. Wähle in der vertikalen Menüleiste links das dritte Feld aus (Source Control). Klicke auf "Clone Repository", es öffnet sich oben mittig eine Eingabeleiste. Füge den zuvor kopierten Link zu deinem Repository ein und bestätige mit Enter.

